package org.jboss.testsample.model;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.annotations.Type;
import org.jboss.errai.common.client.api.annotations.Portable;

@Portable
@Table(name="T_CUSTOM_FIELD")
@Entity
public class CustomField implements Serializable
{
	private static final long serialVersionUID = 1L;

	/*
	 * The index which is set as key in CustomFieldData Map.
	 */
	public static final int CF_01 = 1;
	public static final int CF_02 = 2;
	public static final int CF_03 = 3;
	public static final int CF_04 = 4;
	public static final int CF_05 = 5;
	public static final int CF_06 = 6;
	public static final int CF_07 = 7;
	public static final int CF_08 = 8;
	public static final int CF_09 = 9;
	public static final int CF_10 = 10;
	
	/*
	 * The maximum number of custom fields, which is allowed
	 */
	public static final int CF_MAX = 6;
	
	public CustomField() {
	}

	// TODO: workaround to set ID on the client for DTO
	public CustomField(int id) {
		this.id = id;
	}

	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	@Column(name="id")
	private int id;
	
	
	@Column(name="custom_field")
	private Integer customField;
	
	@Column(name="label")
	private String label;
	
	@Column(name="active")
	@Type(type = "org.hibernate.type.NumericBooleanType")
	private boolean active;
	
	public int getId() {
		return id;
	}

	
	
	public Integer getCustomField() {
		return customField;
	}

	public void setCustomField(Integer customField) {
		this.customField = customField;
	}

	public String getLabel() {
		return label;
	}

	public void setLabel(String label) {
		this.label = label;
	}

	public boolean isActive() {
		return active;
	}

	public void setActive(boolean active) {
		this.active = active;
	}

}
