package org.jboss.testsample.rest;

import java.util.List;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.persistence.EntityManager;

import org.jboss.testsample.model.Member;

@RequestScoped
public class MemberServiceImpl implements MemberService {
	@Inject
	private EntityManager em;

	public MemberServiceImpl(){}

	@Override
	public List<Member> listAllMembers() {
		// Use @SupressWarnings to force IDE to ignore warnings about "genericizing" the results of
		// this query
		@SuppressWarnings("unchecked")
		// We recommend centralizing inline queries such as this one into @NamedQuery annotations on
		// the @Entity class
		// as described in the named query blueprint:
		// https://blueprints.dev.java.net/bpcatalog/ee5/persistence/namedquery.html
		final List<Member> results = em.createQuery("select m from Member m order by m.name").getResultList();
		return results;
	}

	@Override
	public Member lookupMemberById(long id) {
		return em.find(Member.class, id);
	}

}
